'回転強制振動の計算実行ﾌﾟﾛｸﾞﾗﾑ
Imports System.Drawing

Public Class RotFVCal3
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.PictureBox2 = New System.Windows.Forms.PictureBox()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(120, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(200, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "強制振動計算の実行"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'PictureBox2
        '
        Me.PictureBox2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox2.Location = New System.Drawing.Point(112, 144)
        Me.PictureBox2.Name = "PictureBox2"
        Me.PictureBox2.Size = New System.Drawing.Size(224, 24)
        Me.PictureBox2.TabIndex = 3
        Me.PictureBox2.TabStop = False
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(112, 104)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(224, 24)
        Me.PictureBox1.TabIndex = 4
        Me.PictureBox1.TabStop = False
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(32, 192)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(376, 24)
        Me.ProgressBar1.TabIndex = 5
        '
        'RotFVCal3
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(440, 246)
        Me.Controls.Add(Me.ProgressBar1)
        Me.Controls.Add(Me.PictureBox1)
        Me.Controls.Add(Me.PictureBox2)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Name = "RotFVCal3"
        Me.Text = "RotFVCal3"
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim SwK As IO.StreamWriter  '結果出力用

    Dim Ndisp As Integer        'sinとcosの合体変位の総数

    Dim OmegaTAll As Single     '全回転数で最大合成変位のωt

    Dim KDispMAll(4) As Integer '全回転数で各最大変位の節点番号 
    Dim KDispMax(4) As Integer  '各最大変位の節点番号 
    Dim KEfMAll(8) As Integer   '全回転数で力等最大の要素番号 
    Dim KEfmax(8) As Integer    '力等最大の要素番号
    Dim KPfMAll(8) As Integer   '全回転数で力等最大の節点番号
    Dim KPfmax(8) As Integer    '力等最大の節点番号

    Dim Alp() As Single         '各節点の変位の初期角(ﾗｼﾞｱﾝ）
    Dim Alpx() As Single        '前ステップの各節点の変位の初期角(ﾗｼﾞｱﾝ）
    Dim AlpMAll(4) As Single    '全回転数で最大変位の初期角(ﾗｼﾞｱﾝ）
    Dim AlpDispMax(4) As Single '最大変位の初期角(ﾗｼﾞｱﾝ）
    Dim DispMAll(4) As Single   '全回転数で各最大変位の振幅と初期角
    Dim DispMax(4) As Single    '各最大変位の振幅と初期角(ﾗｼﾞｱﾝ）
    Dim DiscProp(,) As Single   '剛性円板の物性値
    Dim Ec(16, 16) As Single    '要素のＣ行列（ｼﾞｬｲﾛ）
    Dim EForce(8), Efb(8) As Single   '要素の軸力等の配列
    Dim Ek(16, 16) As Double    '要素のＫ行列および合計行列
    Dim Em(16, 16) As Single    '要素のＭ行列
    Dim RevDispMAll(4) As Single    '全回転数で力等の最大の回転数
    Dim RevZfMAll(8) As Single  '全回転数で力等の最大の回転数
    Dim RP() As Single          '各節点の変位振幅
    Dim RPx() As Single         '前ステップの各節点の変位振幅
    Dim Tf() As Double          'FEM計算の右辺ベクトル
    Dim Tfb() As Single         '各節点の初期荷重
    Dim TfSum() As Single       '各節点の荷重合計
    Dim Tk(,) As Double         'FEM行列（ﾌﾙﾊﾞﾝﾄﾞ）
    Dim WheelProp(,) As Single  '剛性円輪の物性値
    Dim ZfMAll(8) As Single     '全回転数で力等の最大値
    Dim Zfmax(8) As Single      '力等の最大値

    Private Sub CoeffMatrix(ByVal ie As Integer)
        '各要素の係数ﾏﾄﾘｯｸｽの計算（力等の計算用）
        'ie･･･要素番号
        Dim i, j, kp As Integer
        Dim area, b1, c1, c2, c3, c4, c5 As Single
        Dim dia, dia0, e, g, rimpu, riy, rk As Single
        Dim rlen, rlen2, rlen3, rnyu, rou As Single

        kp = NumMat(ie)
        e = DataMat(kp, 1)
        rnyu = DataMat(kp, 2)
        rou = DataMat(kp, 3)
        dia = DataMat(kp, 4)
        dia0 = DataMat(kp, 5)
        If dia0 = 0 Then    '中実軸
            area = 0.25 * Pai * dia * dia
            riy = (Pai / 64) * dia ^ 4
            rimpu = 0.125 * dia * dia * rou * area
            rk = 6 / 7  '円断面の有効剪断係数
        Else    '中空軸
            area = 0.25 * Pai * (dia * dia - dia0 * dia0)
            riy = (Pai / 64) * (dia ^ 4 - dia0 ^ 4)
            rimpu = 0.125 * (dia * dia + dia0 * dia0) * rou * area

            '捩り解析と重回帰結果から補正
            b1 = dia0 / dia
            c1 = 0.7666 - 0.3029 * b1 ^ 0.5
            rk = c1 * (6 / 7) / 0.7692
        End If
        g = e / (2 * (1 + rnyu))

        rlen = Xdata(ie + 1) - Xdata(ie)
        rlen2 = rlen * rlen
        rlen3 = rlen * rlen2

        b1 = 12 * e * riy / (g * rk * area * rlen2)
        c1 = e * riy / (rlen3 * (1 + b1))
        c2 = 12 * c1
        c3 = 6 * rlen * c1
        c4 = (4 + b1) * rlen2 * c1
        c5 = (2 - b1) * rlen2 * c1

        Ek(1, 1) = c2 : Ek(1, 4) = c3
        Ek(1, 5) = -c2
        Ek(1, 8) = c3
        Ek(2, 2) = c2 : Ek(2, 3) = -c3
        Ek(2, 6) = -c2
        Ek(2, 7) = -c3
        Ek(3, 3) = c4 : Ek(3, 6) = c3
        Ek(3, 7) = c5
        Ek(4, 4) = c4 : Ek(4, 5) = -c3
        Ek(4, 8) = c5
        Ek(5, 5) = c2 : Ek(5, 8) = -c3
        Ek(6, 6) = c2 : Ek(6, 7) = c3
        Ek(7, 7) = c4
        Ek(8, 8) = c4
        For i = 2 To 8
            For j = 1 To i - 1
                Ek(i, j) = Ek(j, i)
            Next j
        Next i

    End Sub

    Private Sub CoeffMatrix2(ByVal ie As Integer, ByVal revx As Single)
        '各要素の係数ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'revx･･･回転数（単位時間当り）
        Dim i, ib, j, kp As Integer
        Dim area, b1, b2, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10, c11 As Single
        Dim cmass, dia, dia0, e, ex, fai, fai2, g, omega, pusai, rimpu, riy, rk As Single
        Dim rlen, rlen2, rlen3, rnyu, rou As Single

        kp = NumMat(ie)
        e = DataMat(kp, 1)
        rnyu = DataMat(kp, 2)
        rou = DataMat(kp, 3)
        dia = DataMat(kp, 4)
        dia0 = DataMat(kp, 5)
        If dia0 = 0 Then    '中実軸
            area = 0.25 * Pai * dia * dia
            riy = (Pai / 64) * dia ^ 4
            rimpu = 0.125 * dia * dia * rou * area
            rk = 6 / 7  '円断面の有効剪断係数
        Else    '中空軸
            area = 0.25 * Pai * (dia * dia - dia0 * dia0)
            riy = (Pai / 64) * (dia ^ 4 - dia0 ^ 4)
            rimpu = 0.125 * (dia * dia + dia0 * dia0) * rou * area

            '捩り解析と重回帰結果から補正
            b1 = dia0 / dia
            c1 = 0.7666 - 0.3029 * b1 ^ 0.5
            rk = c1 * (6 / 7) / 0.7692
        End If
        g = e / (2 * (1 + rnyu))

        rlen = Xdata(ie + 1) - Xdata(ie)
        rlen2 = rlen * rlen
        rlen3 = rlen * rlen2

        b1 = 12 * e * riy / (g * rk * area * rlen2)
        c1 = e * riy / (rlen3 * (1 + b1))
        c2 = 12 * c1
        c3 = 6 * rlen * c1
        c4 = (4 + b1) * rlen2 * c1
        c5 = (2 - b1) * rlen2 * c1

        Ek(1, 1) = c2 : Ek(1, 7) = c3
        Ek(1, 9) = -c2 : Ek(1, 15) = c3
        Ek(3, 3) = c2 : Ek(3, 5) = -c3
        Ek(3, 11) = -c2 : Ek(3, 13) = -c3
        Ek(5, 5) = c4 : Ek(5, 11) = c3
        Ek(5, 13) = c5
        Ek(7, 7) = c4 : Ek(7, 9) = -c3
        Ek(7, 15) = c5
        Ek(9, 9) = c2 : Ek(9, 15) = -c3
        Ek(11, 11) = c2 : Ek(11, 13) = c3
        Ek(13, 13) = c4
        Ek(15, 15) = c4
        For i = 1 To 15 Step 2
            For j = i To 15
                Ek(i + 1, j + 1) = Ek(i, j)
            Next j
        Next i

        omega = Dpai * revx
        cmass = rou * area * rlen
        c1 = -omega * omega * cmass / 420
        c2 = 156 * c1
        c3 = 22 * rlen * c1
        c4 = 54 * c1
        c5 = 13 * rlen * c1
        c6 = 4 * rlen2 * c1
        c7 = 3 * rlen2 * c1

        c1 = -omega * omega * rimpu / (60 * rlen)
        c8 = 36 * c1
        c9 = 3 * rlen * c1
        c10 = 4 * rlen2 * c1
        c11 = rlen2 * c1

        Em(1, 1) = c2 + c8 : Em(1, 7) = c3 + c9
        Em(1, 9) = c4 - c8 : Em(1, 15) = -c5 + c9
        Em(3, 3) = c2 + c8 : Em(3, 5) = -c3 - c9
        Em(3, 11) = c4 - c8 : Em(3, 13) = c5 - c9
        Em(5, 5) = c6 + c10 : Em(5, 11) = -c5 + c9
        Em(5, 13) = -c7 - c11
        Em(7, 7) = c6 + c10 : Em(7, 9) = c5 - c9
        Em(7, 15) = -c7 - c11
        Em(9, 9) = c2 + c8 : Em(9, 15) = -c3 - c9
        Em(11, 11) = c2 + c8 : Em(11, 13) = c3 + c9
        Em(13, 13) = c6 + c10
        Em(15, 15) = c6 + c10
        For i = 1 To 15 Step 2
            For j = i To 15
                Em(i + 1, j + 1) = Em(i, j)
            Next j
        Next i

        c1 = omega * omega * rimpu / (30 * rlen)
        c2 = 36 * c1
        c3 = 3 * rlen * c1
        c4 = 4 * rlen2 * c1
        c5 = rlen2 * c1

        Ec(1, 4) = c2 : Ec(1, 6) = -c3
        Ec(1, 12) = -c2 : Ec(1, 14) = -c3
        Ec(3, 8) = -c3 : Ec(3, 10) = c2
        Ec(3, 16) = -c3
        Ec(5, 8) = c4 : Ec(5, 10) = -c3
        Ec(5, 16) = -c5
        Ec(7, 12) = -c3 : Ec(7, 14) = c5
        Ec(9, 12) = c2 : Ec(9, 14) = c3
        Ec(11, 16) = c3
        Ec(13, 16) = c4
        For i = 1 To 15 Step 2
            For j = i + 1 To 16
                Ec(i + 1, j - 1) = Ec(i, j)
            Next j
        Next i

        '要素行列の合計
        For i = 1 To 16
            For j = i To 16
                Ek(i, j) = Ek(i, j) + Em(i, j) + Ec(i, j)
            Next j
        Next i
        For i = 2 To 16
            For j = 1 To i - 1
                Ek(i, j) = Ek(j, i)
            Next j
        Next i

        '荷重の設定
        i = 4 * (ie - 1)
        b1 = RPx(i + 1) + RPx(i + 2)
        i = 4 * ie
        b2 = RPx(i + 1) + RPx(i + 2)
        ex = 0.25 * (b1 + b2)
        If DataElem(ie, 1) <> 0 Then
            ex = ex + DataElem(ie, 1)
            fai = DataElem(ie, 2) * Pai / 180
        Else
            fai = 0
        End If
        b1 = cmass * ex * omega * omega
        c1 = 0.5 * b1 * Math.Cos(fai)
        c2 = 0.5 * b1 * Math.Sin(fai)
        ib = 8 * (ie - 1)
        Tf(ib + 1) = Tf(ib + 1) + c1
        Tf(ib + 2) = Tf(ib + 2) - c2
        Tf(ib + 3) = Tf(ib + 3) + c2
        Tf(ib + 4) = Tf(ib + 4) + c1
        ib = 8 * ie
        Tf(ib + 1) = Tf(ib + 1) + c1
        Tf(ib + 2) = Tf(ib + 2) - c2
        Tf(ib + 3) = Tf(ib + 3) + c2
        Tf(ib + 4) = Tf(ib + 4) + c1
        If DataElem(ie, 3) <> 0 Then
            fai = DataElem(ie, 2) * Pai / 180
            pusai = DataElem(ie, 3) * Pai / 180
            fai2 = DataElem(ie, 4) * Pai / 180
            b1 = 0.5 * rimpu * rlen * pusai * omega * omega
            c1 = 0.5 * b1 * Math.Cos(fai + fai2)
            c2 = 0.5 * b1 * Math.Sin(fai + fai2)
            ib = 8 * (ie - 1)
            Tf(ib + 5) = Tf(ib + 5) + c1
            Tf(ib + 6) = Tf(ib + 6) - c2
            Tf(ib + 7) = Tf(ib + 7) + c2
            Tf(ib + 8) = Tf(ib + 8) + c1
            ib = 8 * ie
            Tf(ib + 5) = Tf(ib + 5) + c1
            Tf(ib + 6) = Tf(ib + 6) - c2
            Tf(ib + 7) = Tf(ib + 7) + c2
            Tf(ib + 8) = Tf(ib + 8) + c1
        End If

    End Sub

    Private Sub DampSet(ByVal revx As Single)
        'ﾀﾞﾝﾊﾟｰの設定
        'revx･･･回転数（単位時間当り）
        Dim i, j, k As Integer
        Dim b1, omega As Single

        omega = Dpai * revx
        For i = 1 To Ndamp
            k = 8 * (KPdamp(i) - 1)
            For j = 1 To 2
                b1 = omega * Cdamp(i, j)
                k = k + 1
                Tk(k, 9) = Tk(k, 9) + b1
                k = k + 1
                Tk(k, 7) = Tk(k, 7) - b1
            Next j
        Next i

    End Sub

    Private Sub Debug1()
        '要素ﾏﾄﾘｯｸｽを出力して停止
        Dim a1$, aa$, fxx$
        Dim i, j, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\RotFVdebug1.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "要素マトリックス"
        WriteLine(ii, aa$)
        For i = 1 To 16
            WriteLine(ii, "行", i)
            For j = 1 To 8
                a1$ = Str(Ek(i, j))
                If j = 1 Then
                    aa$ = a1$
                Else
                    aa$ = aa$ + ",  " + a1$
                End If
            Next j
            PrintLine(ii, aa$)
            For j = 9 To 16
                a1$ = Str(Ek(i, j))
                If j = 9 Then
                    aa$ = a1$
                Else
                    aa$ = aa$ + ",  " + a1$
                End If
            Next j
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub Debug5(ByVal nx As Integer)
        '右辺ﾍﾞｸﾄﾙを出力して停止
        'nx･･･変数の数
        Dim aa$, fxx$
        Dim i, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\RotFVdebug2.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "右辺ベクトル"
        WriteLine(ii, aa$)
        WriteLine(ii, "行番号、右辺値")
        For i = 1 To nx
            aa$ = Str$(i)
            aa$ = aa$ + ",  " + Str$(Tf(i))
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub DiscPrep()     '剛性円板の物性値準備
        Dim i As Integer
        Dim area, b1, b2, cmass, d1, d2, h, rimd, rimpd As Single
        ReDim DiscProp(Ndisc, 3)
        For i = 1 To Ndisc
            d1 = DiscData(i, 2)
            d2 = DiscData(i, 3)
            h = DiscData(i, 4)
            b1 = 0.25 * Pai * d1 * d1
            b2 = 0.25 * Pai * d2 * d2
            area = b1 - b2
            cmass = DiscData(i, 1) * area * h
            b1 = 0.125 * (d1 * d1 + d2 * d2)
            rimpd = b1 * cmass
            rimd = 0.5 * rimpd + cmass * h * h / 12
            DiscProp(i, 1) = cmass
            DiscProp(i, 2) = rimpd
            DiscProp(i, 3) = rimd
        Next i

    End Sub

    Private Sub DiscSet(ByVal revx As Single)
        '剛性円板の設定
        'revx･･･回転数（単位時間当り）
        Dim i, ib, j, k, kb, m As Integer
        Dim b1, c1, c2, c3, cmass, ex, fai, fai2, omega, pusai, rimd, rimpd As Single

        omega = Dpai * revx
        For i = 1 To Ndisc
            cmass = DiscProp(i, 1)
            rimpd = DiscProp(i, 2)
            rimd = DiscProp(i, 3)
            c1 = -omega * omega * cmass
            c2 = omega * omega * rimd
            k = 8 * (KPdisc(i) - 1)
            For j = 1 To 4
                kb = k + j
                Tk(kb, 8) = c1
            Next j
            For j = 5 To 8
                kb = k + j
                m = kb Mod 2
                If m > 0 Then
                    Tk(kb, 9) = c2
                Else
                    Tk(kb, 7) = -c2
                End If
            Next j

            c3 = omega * omega * rimpd
            For j = 5 To 6
                kb = k + j
                If j = 5 Then
                    Tk(kb, 11) = c2
                Else
                    Tk(kb, 9) = -c2
                End If
            Next j
            For j = 7 To 8
                kb = k + j
                If j = 7 Then
                    Tk(kb, 7) = -c2
                Else
                    Tk(kb, 5) = c2
                End If
            Next j

            '荷重の設定
            ib = 4 * (KPdisc(i) - 1)
            ex = 0.5 * (RPx(ib + 1) + RPx(ib + 2))
            If DiscData(i, 5) > 0 Then
                ex = ex + DiscData(i, 5)
                fai = DiscData(i, 6) * Pai / 180
            Else
                fai = 0
            End If
            b1 = cmass * ex * omega * omega
            c1 = b1 * Math.Cos(fai)
            c2 = b1 * Math.Sin(fai)
            Tf(k + 1) = Tf(k + 1) + c1
            Tf(k + 2) = Tf(k + 2) - c2
            Tf(k + 3) = Tf(k + 3) + c2
            Tf(k + 4) = Tf(k + 4) + c1
            If DiscData(i, 7) <> 0 Then
                fai = DiscData(i, 6) * Pai / 180
                pusai = DiscData(i, 7) * Pai / 180
                fai2 = DiscData(i, 8) * Pai / 180
                b1 = 0.5 * rimpd * pusai * omega * omega
                c1 = b1 * Math.Cos(fai + fai2)
                c2 = b1 * Math.Sin(fai + fai2)
                Tf(k + 5) = Tf(k + 5) + c1
                Tf(k + 6) = Tf(k + 6) - c2
                Tf(k + 7) = Tf(k + 7) + c2
                Tf(k + 8) = Tf(k + 8) + c1
            End If

        Next i

    End Sub

    Private Sub DispAssy(ByVal b1 As Single, ByVal b2 As Single, _
        ByRef r As Single, ByRef alpha As Single)
        '変位の合成
        'b1,b2･･･cosωt、sinωtの係数
        'r･･･合成変位の振幅
        'alpha･･･初期位相角(ﾗｼﾞｱﾝ)
        Dim cosb, hpai, sinb As Single

        hpai = 0.5 * Pai
        r = Math.Sqrt(b1 * b1 + b2 * b2)
        If r = 0 Then
            alpha = 0
            Exit Sub
        End If
        sinb = b1 / r
        cosb = b2 / r
        If cosb = 0 Then
            If sinb > 0 Then
                alpha = hpai
            Else
                alpha = hpai + Pai
            End If
        Else
            alpha = Math.Acos(cosb)
            If sinb < 0 Then
                alpha = Dpai - alpha
            End If
        End If

    End Sub

    Private Sub DispAssyA()
        '変位の合成A
        'b1,b2･･･cosωt、sinωtの係数
        'r･･･合成変位の振幅
        'alpha･･･初期位相角(ﾗｼﾞｱﾝ)
        Dim i, j, k, kp As Integer
        Dim alpha, b1, b2, cosb, hpai, r, sinb As Single

        hpai = 0.5 * Pai
        For i = 1 To Nelem + 1
            k = 8 * (i - 1)
            kp = 4 * (i - 1)
            For j = 1 To 4
                k = k + 1
                b1 = Tf(k)
                k = k + 1
                b2 = Tf(k)
                r = Math.Sqrt(b1 * b1 + b2 * b2)
                If r = 0 Then
                    alpha = 0
                Else
                    sinb = b1 / r
                    cosb = b2 / r
                    If cosb = 0 Then
                        If sinb > 0 Then
                            alpha = hpai
                        Else
                            alpha = hpai + Pai
                        End If
                    Else
                        alpha = Math.Acos(cosb)
                        If sinb < 0 Then
                            alpha = Dpai - alpha
                        End If
                    End If
                End If

                kp = kp + 1
                RP(kp) = r
                Alp(kp) = alpha
            Next j
        Next i

    End Sub

    Private Sub DispMaxCalc(ByVal kk As Integer, ByRef kdiv As Integer, _
        ByRef rmax As Single)
        '最大変位の計算
        'kk･･･節点番号
        'omegat･･･回転角(ﾗｼﾞｱﾝ)
        'rmax･･･最大変位(ﾍﾞｸﾄﾙ合成)
        Dim k, kp As Integer
        Dim a1, a2, b1, b2, b3, b4, bmax, delta, r1, r2 As Single

        kp = 4 * (kk - 1)
        r1 = RP(kp + 1)
        a1 = Alp(kp + 1)
        r2 = RP(kp + 2)
        a2 = Alp(kp + 2)
        delta = Dpai / 360

        bmax = 0
        For k = 0 To 199
            b1 = k * delta
            b2 = r1 * Math.Sin(b1 + a1)
            b3 = r2 * Math.Sin(b1 + a2)
            b4 = b2 * b2 + b3 * b3
            If b4 > bmax Then
                bmax = b4
                kdiv = k
            End If
        Next k

        rmax = Math.Sqrt(bmax)

    End Sub

    Private Sub ElemMatrix(ByVal ie As Integer)
        '要素ﾏﾄﾘｯｸｽの計算（力等の計算用）
        'ie･･･要素番号
        'istage･･･応力計算の有無（0:なし、1:有り）
        Dim ib, id, ii, j, k As Integer

        j = 0
        For ii = 1 To 2
            If ii = 1 Then
                ib = ie
            Else
                ib = ie + 1
            End If
            k = 8 * (ib - 1)
            For id = 1 To 4
                j = j + 1
                k = k + 1
                NPrefer(j) = k
                Efb(j) = RP(j)
            Next id
        Next ii

        For ib = 1 To 8
            EForce(ib) = 0
            For j = 1 To 8
                Ek(ib, j) = 0
            Next j
        Next ib

        Call CoeffMatrix(ie) '各要素の係数ﾏﾄﾘｯｸｽの計算

    End Sub

    Private Sub ElemMatrix2(ByVal ie As Integer, ByVal revx As Single)
        '要素ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'revx･･･回転数（単位時間当り）
        Dim ib, id, ii, j, k As Integer
        j = 0
        For ii = 1 To 2
            If ii = 1 Then
                ib = ie
            Else
                ib = ie + 1
            End If
            k = 8 * (ib - 1)
            For id = 1 To 8
                j = j + 1
                k = k + 1
                NPrefer(j) = k
            Next id
        Next ii

        For ib = 1 To 16
            For j = 1 To 16
                Ek(ib, j) = 0
                Em(ib, j) = 0
                Ec(ib, j) = 0
            Next j
        Next ib

        Call CoeffMatrix2(ie, revx) '各要素の係数ﾏﾄﾘｯｸｽの計算

    End Sub

    Private Sub FMaxMin(ByRef ic As Integer, ByVal ie As Integer, _
    ByVal ii As Integer, ByVal buf() As Single)
        '軸力等の最大・最小のﾁｪｯｸ
        'ic･･･初期設定の有無（0:なし、1:有り）
        'ie･･･要素番号
        'ii･･･節点番号
        'buf()･･･各力等
        Dim i As Integer

        If ic = 0 Then
            For i = 1 To 8
                KEfmax(i) = 1
                KPfmax(i) = 1
                Zfmax(i) = buf(i)
            Next i
            ic = 1
        Else
            For i = 1 To 8
                If buf(i) > Zfmax(i) Then
                    KEfmax(i) = ie
                    KPfmax(i) = ii
                    Zfmax(i) = buf(i)
                End If
            Next i
        End If

    End Sub

    Private Sub ForceCalc(ByVal revx As Single)
        '力等の計算
        'revx･･･回転数（単位時間当り）
        Dim a1$, a3$, a4$, aa$, ad$
        Dim i, ib, ic, icount, ie, ii, j, jj, k, kb, mf, nx As Integer
        Dim area, b1, cs, dia, dia0, zb, s As Single
        Dim buf(8) As Single

        a1$ = ""
        ad$ = "-------------------------------------------------------"
        aa$ = "要素No.、節点No.，ＦyB、ＦzB、ＭyB、ＭzB、τy、τz、σby、σbz"
        SwK.WriteLine(ad$)
        SwK.WriteLine("＜力・応力等＞")
        SwK.WriteLine(aa$)
        nx = 4 * (Nelem + 1)
        mf = 8
        For i = 1 To nx
            Tf(i) = 0
            TfSum(i) = 0
            For j = 1 To mf
                Tk(i, j) = 0
            Next j
        Next i

        icount = 0
        For ie = 1 To Nelem
            Call ElemMatrix(ie)    '要素ﾏﾄﾘｯｸｽの計算
            For ib = 1 To 8
                s = 0
                For j = 1 To 8
                    s = s + Ek(ib, j) * Efb(j)
                Next j
                EForce(ib) = s
            Next ib

            For ib = 1 To 8
                s = 0
                For j = 1 To 8
                    s = s + Ek(ib, j) * Efb(j)
                Next j
                EForce(ib) = s
            Next ib
            kb = NumMat(ie)
            dia = DataMat(kb, 4)
            dia0 = DataMat(kb, 5)
            If dia0 = 0 Then
                area = 0.25 * Pai * dia * dia
                zb = Pai * dia ^ 3 / 32
                cs = 1.333
            Else
                area = 0.25 * Pai * (dia * dia - dia0 * dia0)
                zb = Pai * (dia ^ 4 - dia0 ^ 4) / dia / 32

                '捩り解析の重回帰
                b1 = dia0 / dia
                cs = 1 / (0.7666 - 0.3029 * b1 ^ 0.5)
            End If

            For j = 1 To 2
                If j = 1 Then
                    ii = ie
                Else
                    ii = ie + 1
                End If
                ib = 4 * (ii - 1)
                jj = 4 * (j - 1)
                For k = 1 To 4
                    buf(k) = EForce(jj + k)
                    TfSum(ib + k) = TfSum(ib + k) + buf(k)
                Next k
                buf(5) = Math.Abs(cs * buf(1) / area)
                buf(6) = Math.Abs(cs * buf(2) / area)
                buf(7) = Math.Abs(buf(3) / zb)
                buf(8) = Math.Abs(buf(4) / zb)
                aa$ = Str(ie) + ",  " + Str(ii)
                For k = 1 To 8
                    aa$ = aa$ + ",  " + Str(buf(k))
                Next k
                SwK.WriteLine(aa$)
                Call FMaxMin(ic, ie, ii, buf) '力等の最大・最小のﾁｪｯｸ
            Next j
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        aa$ = "変数項目、    変数値、         要素番号、   節点番号"
        SwK.WriteLine(ad$)
        SwK.WriteLine("＜最大値集計＞")
        SwK.WriteLine(aa$)
        For i = 1 To 8
            Select Case i
                Case 1
                    a1$ = "ＦyB"
                Case 2
                    a1$ = "ＦzB"
                Case 3
                    a1$ = "ＭyB"
                Case 4
                    a1$ = "ＭzB"
                Case 5
                    a1$ = "τy"
                Case 6
                    a1$ = "τz"
                Case 7
                    a1$ = "σby"
                Case 8
                    a1$ = "σbz"
            End Select
            If i = 5 Or i = 6 Then
                j = 6
            Else
                j = 5
            End If
            aa$ = a1$ + " max," + Space(j)
            a3$ = Str(Zfmax(i))
            a4$ = Space(16 - Len(a3$))
            aa$ = aa$ + a3$ + "," + a4$
            a3$ = Str(KEfmax(i))
            a4$ = Space(12 - Len(a3$))
            aa$ = aa$ + a3$ + "," + a4$
            aa$ = aa$ + Str(KPfmax(i))
            SwK.WriteLine(aa$)
            If Zfmax(i) > ZfMAll(i) Then
                KEfMAll(i) = KEfmax(i)
                KPfMAll(i) = KPfmax(i)
                ZfMAll(i) = Zfmax(i)
                RevZfMAll(i) = revx
            End If
        Next i

        aa$ = "節点番号，Ｆy、Ｆz、Ｍy、Ｍz"
        SwK.WriteLine(ad$)
        SwK.WriteLine("＜全節点の荷重＞")
        SwK.WriteLine(aa$)
        For i = 1 To Nelem + 1
            aa$ = Str(i)
            ib = 4 * (i - 1)
            For j = 1 To 4
                aa$ = aa$ + ",  " + Str(TfSum(ib + j))
            Next j
            SwK.WriteLine(aa$)
        Next i

        If Nbound > 0 Then
            aa$ = "節点番号，Ｆy、Ｆz、Ｍy、Ｍz"
            SwK.WriteLine(ad$)
            SwK.WriteLine("＜拘束節点の反力＞")
            SwK.WriteLine(aa$)
            For i = 1 To Nbound
                aa$ = Str(Nrest(i))
                k = 4 * (Nrest(i) - 1)
                For j = 1 To 4
                    zb = TfSum(k + j) - Tfb(k + j)
                    aa$ = aa$ + ",  " + Str(zb)
                Next j
                SwK.WriteLine(aa$)
            Next i
        End If

    End Sub

    Private Sub InitialSet1()
        '初期設定

        Nall = 8 * (Nelem + 1)
        Ndisp = 4 * (Nelem + 1)

        ReDim NPrefer(16)
        ReDim Tk(Nall, 31), Tf(Nall), Tfb(Nall), TfSum(Ndisp)
        ReDim Alp(Ndisp), Alpx(Ndisp), RP(Ndisp), RPx(Ndisp)

    End Sub

    Private Sub ResFile1U()
        '結果ﾌｧｲﾙへの出力1
        'UTF-8･･･BOMなし
        Dim aa$, ad$
        Dim mf As Integer

        ad$ = "-------------------------------------------------------"
        SwK = New IO.StreamWriter(Fy$)  '結果出力用
        aa$ = "＜＜回転強制振動解析の計算結果＞＞"
        SwK.WriteLine(aa$)
        SwK.WriteLine(Title$)
        aa$ = "［入力データファイル］" + "," + Fm$
        SwK.WriteLine(aa$)
        aa$ = "回転数MIN、MAX、分割数" + "," + Str(RevMin)
        aa$ = aa$ + "," + Str(RevMax) + "," + Str(MeshRev)
        SwK.WriteLine(aa$)
        aa$ = "最大繰返し計算回数、収束基準誤差率" + "," + Str(NKmax)
        aa$ = aa$ + "," + Str(EpsCalc)
        SwK.WriteLine(aa$)
        SwK.WriteLine(ad$)
        mf = 31
        SwK.WriteLine("＊＊＊ 計算結果 ＊＊＊")
        aa$ = "フルバンド幅" + "," + Str(mf)
        SwK.WriteLine(aa$)

    End Sub

    Private Sub ResFile3(ByVal iconv As Integer, ByVal nk As Integer, _
        ByVal krev As Integer, ByVal eps As Single, ByVal revx As Single)
        '結果ﾌｧｲﾙへの出力3
        'iconv･･･収束有無（0:なし、1:有り）
        'nk･･･繰返し回数
        'krev･･･回転数のﾒｯｼｭ番号（0～MeshRev）
        'eps･･･誤差率
        'revx･･･回転数（単位時間当り）
        Dim aa$, ad$
        Dim i, ib, j, k, kdiv, kk, kp As Integer
        Dim alpha, b1, b2, b3, bmax, c, cosb, sinb, omegat, r, rmax As Single

        aa$ = ""
        ad$ = "-------------------------------------------------------"
        SwK.WriteLine(ad$)
        SwK.WriteLine(ad$)
        aa$ = "回転数のメッシュ番号" + "," + Str(krev)
        SwK.WriteLine(aa$)
        aa$ = "回転数" + "," + Str(revx)
        SwK.WriteLine(aa$)
        If NKmax > 1 Then
            If iconv = 0 Then
                aa$ = "非収束計算回数、誤差率"
            Else
                aa$ = "収束計算回数、誤差率"
            End If
        Else
            aa$ = "計算回数、誤差率"
            eps = 0
        End If
        SwK.WriteLine(aa$)
        aa$ = Str(nk) + ",  " + Str(eps)
        SwK.WriteLine(aa$)

        For i = 1 To 4
            KDispMax(4) = 0
            DispMax(4) = 0
        Next i
        bmax = 0

        aa$ = "節点番号，振幅Ry、初期角αy、振幅Rz、初期角αz、振幅θy、初期角βy、"
        aa$ = aa$ + "振幅θz、初期角βz"
        SwK.WriteLine("＜変位関係＞")
        SwK.WriteLine(aa$)
        For i = 1 To Nelem + 1
            aa$ = Str(i)
            kp = 4 * (i - 1)
            b3 = 0
            For j = 1 To 4
                kp = kp + 1
                r = RP(kp)
                alpha = Alp(kp)
                c = alpha * 180 / Pai
                aa$ = aa$ + ",  " + Str(r) + ",  " + Str(c)
                If j < 3 Then
                    b3 = b3 + r * r
                End If
                If r > DispMax(j) Then
                    KDispMax(j) = i
                    DispMax(j) = r
                End If
            Next j
            SwK.WriteLine(aa$)
            If i = 1 Or b3 > bmax Then
                bmax = b3
                kk = i
            End If
        Next i
        Call DispMaxCalc(kk, kdiv, rmax) '最大変位の計算
        For j = 1 To 4
            If DispMax(j) > DispMAll(j) Then
                KDispMAll(j) = KDispMax(j)
                DispMAll(j) = DispMax(j)
                RevDispMAll(j) = revx
            End If
        Next j
        If rmax > DispMAll(0) Then
            KDispMAll(0) = kk
            DispMAll(0) = rmax
            RevDispMAll(0) = revx
        End If

        SwK.WriteLine(ad$)
        SwK.WriteLine("＊＊ 最大変位時の出力 ＊＊")
        aa$ = "最大変位の節点番号、ωt(°)、変位δR"
        SwK.WriteLine(aa$)
        aa$ = "  " + Str(kk) + ",  " + Str(kdiv) + ",  " + Str(rmax)
        SwK.WriteLine(aa$)
        omegat = kdiv * Pai / 180
        cosb = Math.Cos(omegat)
        sinb = Math.Sin(omegat)
        aa$ = "節点番号，δY、δZ、θy、θz"
        SwK.WriteLine("＜変位＞")
        SwK.WriteLine(aa$)
        For i = 1 To Nelem + 1
            aa$ = Str(i)
            kp = 4 * (i - 1)
            For j = 1 To 4
                kp = kp + 1
                b1 = omegat + Alp(kp)
                b2 = RP(kp) * Math.Sin(omegat + Alp(kp))
                aa$ = aa$ + ",  " + Str(b2)
                RP(kp) = b2
            Next j
            SwK.WriteLine(aa$)
            kp = 4 * (i - 1)
            ib = 8 * (i - 1)
            For j = 1 To 4
                kp = kp + 1
                k = ib + 2 * (j - 1) + 1
                Tfb(kp) = Tfb(k) * cosb + Tfb(k + 1) * sinb
            Next j
        Next i

    End Sub

    Private Sub ResFile4()
        '結果ﾌｧｲﾙへの出力4
        Dim a1$, a3$, a4$, aa$, ad$
        Dim i, j As Integer

        a1$ = ""
        ad$ = "-------------------------------------------------------"
        aa$ = "＜各回転数最大変位時の集計＞"
        SwK.WriteLine(ad$)
        SwK.WriteLine(ad$)
        SwK.WriteLine(aa$)
        CalcRes$ = aa$
        aa$ = "変数項目、    変数値、         節点番号、   回転数"
        CalcRes$ = CalcRes$ + Chr(13) + Chr(10) + aa$
        SwK.WriteLine(aa$)
        For i = 0 To 4
            Select Case i
                Case 0
                    a1$ = "全δ"
                Case 1
                    a1$ = "δY"
                Case 2
                    a1$ = "δZ"
                Case 3
                    a1$ = "θy"
                Case 4
                    a1$ = "θz"
            End Select
            If i = 0 Then
                j = 5
            Else
                j = 6
            End If
            aa$ = a1$ + " max," + Space(j)
            a3$ = Str(DispMAll(i))
            a4$ = Space(16 - Len(a3$))
            aa$ = aa$ + a3$ + "," + a4$
            a3$ = Str(KDispMAll(i))
            a4$ = Space(12 - Len(a3$))
            aa$ = aa$ + a3$ + "," + a4$
            aa$ = aa$ + Str(RevDispMAll(i))
            SwK.WriteLine(aa$)
            CalcRes$ = CalcRes$ + Chr(13) + Chr(10) + aa$
        Next i

        aa$ = "変数項目、    変数値、         要素番号、   節点番号、   回転数"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        For i = 1 To 8
            Select Case i
                Case 1
                    a1$ = "ＦyB"
                Case 2
                    a1$ = "ＦzB"
                Case 3
                    a1$ = "ＭyB"
                Case 4
                    a1$ = "ＭzB"
                Case 5
                    a1$ = "τy"
                Case 6
                    a1$ = "τz"
                Case 7
                    a1$ = "σby"
                Case 8
                    a1$ = "σbz"
            End Select
            If i = 5 Or i = 6 Then
                j = 6
            Else
                j = 5
            End If
            aa$ = a1$ + " max," + Space(j)
            a3$ = Str(ZfMAll(i))
            a4$ = Space(16 - Len(a3$))
            aa$ = aa$ + a3$ + "," + a4$
            a3$ = Str(KEfMAll(i))
            a4$ = Space(12 - Len(a3$))
            aa$ = aa$ + a3$ + "," + a4$
            a3$ = Str(KPfMAll(i))
            a4$ = Space(12 - Len(a3$))
            aa$ = aa$ + a3$ + "," + a4$
            aa$ = aa$ + Str(RevZfMAll(i))
            SwK.WriteLine(aa$)
            CalcRes$ = CalcRes$ + Chr(13) + Chr(10) + aa$
        Next i

    End Sub

    Private Sub RestCond(ByVal k As Integer, ByVal mh As Integer, _
    ByVal nx As Integer)
        '拘束条件処理（0に固定）
        'k･･･変数番号
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･全変数の数
        Dim it, j, jj, jt, ka, mx As Integer

        If k > 1 Then
            ka = k - mh + 1
            If ka < 1 Then
                ka = 1
            End If
            For it = ka To k - 1
                j = k - it + mh
                jj = mh - k + it
                Tk(it, j) = 0
                Tk(k, jj) = 0
            Next it
        End If
        If k < nx Then
            mx = mh
            If k + mh - 1 > nx Then
                mx = nx - k + 1
            End If
            For j = 2 To mx
                it = k + j - 1
                jt = mh + j - 1
                jj = mh - j + 1
                Tk(k, jt) = 0
                Tk(it, jj) = 0
            Next j
        End If
        Tk(k, mh) = 1
        Tf(k) = 0

    End Sub

    Private Sub Solver1(ByRef ierror As Integer, ByVal mh As Integer, _
    ByVal nx As Integer)
        'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1（前進側）
        'ierror･･･ｴﾗｰ有無（0：なし、-1：有り）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･全変数の数
        Dim aa$, c1$, c2$, timn$
        Dim i, icount, it, j, jj, jt, k, mx As Integer
        Dim b1 As Double
        Dim buf(mh) As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ1 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)
        ierror = 0
        icount = 0
        For k = 1 To nx - 1
            mx = mh
            If k + mh - 1 > nx Then
                mx = nx - k + 1
            End If
            b1 = Tk(k, mh)
            If b1 = 0 Then
                c1$ = "計算実行エラー"
                c2$ = "ソルバー１の変数番号" + LTrim$(Str$(k)) + "で"
                c2$ = c2$ + "ピボット変数が０になりました。"
                MsgBox(c2$, 0, c1$)
                ierror = -1
                Exit Sub
            End If
            For j = 2 To mx
                jj = mh + j - 1
                buf(j) = Tk(k, jj) / b1
                Tk(k, jj) = buf(j)
            Next j
            Tf(k) = Tf(k) / b1
            For i = 2 To mx
                it = i + k - 1
                jj = mh - i + 1
                b1 = Tk(it, jj)
                If b1 <> 0 Then
                    For j = 2 To mx
                        If buf(j) <> 0 Then
                            jt = j - i + mh
                            Tk(it, jt) = Tk(it, jt) - b1 * buf(j)
                        End If
                    Next j
                    Tf(it) = Tf(it) - b1 * Tf(k)
                End If
            Next i
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next k
        gr.Dispose()

    End Sub

    Private Sub Solver2(ByVal mh As Integer, ByVal nx As Integer)
        'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（後退側）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･全変数の数
        Dim aa$, timn$
        Dim j, jj, jt, k, mx As Integer
        Dim s As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)
        For k = nx - 1 To 1 Step -1
            s = 0
            mx = mh
            If k + mh - 1 > nx Then
                mx = nx - k + 1
            End If
            For j = 2 To mx
                jt = j + k - 1
                jj = mh + j - 1
                s = s + Tk(k, jj) * Tf(jt)
            Next j
            Tf(k) = Tf(k) - s
        Next k
        gr.Dispose()

    End Sub

    Private Sub SpringSet1()
        'ﾊﾞﾈ支持の設定1
        Dim ib, j, k As Integer

        For ib = 1 To Nspring
            k = 8 * (KPspring(ib) - 1)
            For j = 1 To 2
                k = k + 1
                Tk(k, 8) = Tk(k, 8) - Cspring(ib, j)
                k = k + 1
                Tk(k, 8) = Tk(k, 8) - Cspring(ib, j)
            Next j
        Next ib

    End Sub

    Private Sub Store()
        '全体ﾏﾄﾘｯｸｽへの蓄積
        Dim i, it, j, jb, jt As Integer

        For i = 1 To 16
            it = NPrefer(i)
            For j = 1 To 16
                jt = NPrefer(j)
                jb = jt - it + 16
                Tk(it, jb) = Tk(it, jb) + Ek(i, j)
            Next j
        Next i

    End Sub

    Private Sub WheelPrep()     '剛性円輪の物性値準備
        Dim i, ic, k As Integer
        Dim area, b1, b2, cmass, cmb, d1, d2, eps, h As Single
        Dim rib1, rib2, rimd, rimpd, rl1, rl2, rlx, rou As Single
        ReDim WheelProp(Nwheel, 3)
        For i = 1 To Nwheel
            cmass = 0 : rimd = 0 : rimpd = 0
            eps = WheelData(i, 3) * 0.0001
            rou = WheelData(i, 1)
            rlx = WheelData(i, 2)
            For k = 1 To 5
                ic = 0
                Select Case k
                    Case 1
                        rl1 = WheelData(i, 6)
                        rl2 = WheelData(i, 3) - WheelData(i, 7)
                        h = rl2 - rl1
                        If h > eps Then
                            ic = 1
                            d1 = WheelData(i, 8)
                            d2 = WheelData(i, 9)
                        End If
                    Case 2
                        h = WheelData(i, 4)
                        If h > 0 Then
                            ic = 1
                            rl2 = WheelData(i, 6)
                            rl1 = rl2 - h
                            d1 = WheelData(i, 10)
                            d2 = WheelData(i, 9)
                        End If
                    Case 3
                        h = WheelData(i, 5)
                        If h > 0 Then
                            ic = 1
                            rl1 = WheelData(i, 3) - WheelData(i, 7)
                            rl2 = rl1 + h
                            d1 = WheelData(i, 11)
                            d2 = WheelData(i, 9)
                        End If
                    Case 4
                        h = WheelData(i, 6)
                        If h > 0 Then
                            ic = 1
                            rl1 = 0
                            rl2 = h
                            d1 = WheelData(i, 8)
                            d2 = WheelData(i, 12)
                        End If
                    Case 5
                        h = WheelData(i, 7)
                        If h > 0 Then
                            ic = 1
                            rl2 = WheelData(i, 3)
                            rl1 = rl2 - h
                            d1 = WheelData(i, 8)
                            d2 = WheelData(i, 13)
                        End If
                End Select
                If ic > 0 Then
                    b1 = 0.25 * Pai * d1 * d1
                    b2 = 0.25 * Pai * d2 * d2
                    area = b1 - b2
                    cmb = rou * area * h
                    cmass = cmass + cmb
                    b1 = 0.125 * (d1 * d1 + d2 * d2)
                    rib1 = b1 * cmb
                    rimpd = rimpd + rib1
                    rib2 = 0.5 * rib1 + cmb * h * h / 12
                    b1 = rlx - 0.5 * (rl1 + rl2)
                    rib2 = rib2 + cmb * b1 * b1
                    rimd = rimd + rib2
                End If
            Next k
            WheelProp(i, 1) = cmass
            WheelProp(i, 2) = rimpd
            WheelProp(i, 3) = rimd
        Next i

    End Sub

    Private Sub WheelSet(ByVal revx As Single)
        '剛性円輪の設定
        'revx･･･回転数（単位時間当り）
        Dim i, ib, j, k, kb, m As Integer
        Dim b1, c1, c2, c3, cmass, omega, ex, fai, fai2, pusai, rimd, rimpd As Single

        omega = Dpai * revx
        For i = 1 To Nwheel
            cmass = WheelProp(i, 1)
            rimpd = WheelProp(i, 2)
            rimd = WheelProp(i, 3)
            c1 = -omega * omega * cmass
            c2 = omega * omega * rimd
            k = 8 * (KPwheel(i) - 1)
            For j = 1 To 4
                kb = k + j
                Tk(kb, 8) = c1
            Next j
            For j = 5 To 8
                kb = k + j
                m = kb Mod 2
                If m > 0 Then
                    Tk(kb, 9) = c2
                Else
                    Tk(kb, 7) = -c2
                End If
            Next j

            c3 = omega * omega * rimpd
            For j = 5 To 6
                kb = k + j
                If j = 5 Then
                    Tk(kb, 11) = c2
                Else
                    Tk(kb, 9) = -c2
                End If
            Next j
            For j = 7 To 8
                kb = k + j
                If j = 7 Then
                    Tk(kb, 7) = -c2
                Else
                    Tk(kb, 5) = c2
                End If
            Next j

            '荷重の設定
            ib = 4 * (KPwheel(i) - 1)
            ex = 0.5 * (RPx(ib + 1) + RPx(ib + 2))
            If WheelData(i, 14) > 0 Then
                ex = ex + WheelData(i, 14)
                fai = WheelData(i, 15) * Pai / 180
            Else
                fai = 0
            End If
            b1 = cmass * ex * omega * omega
            c1 = b1 * Math.Cos(fai)
            c2 = b1 * Math.Sin(fai)
            Tf(k + 1) = Tf(k + 1) + c1
            Tf(k + 2) = Tf(k + 2) - c2
            Tf(k + 3) = Tf(k + 3) + c2
            Tf(k + 4) = Tf(k + 4) + c1
            If WheelData(i, 16) <> 0 Then
                fai = WheelData(i, 15) * Pai / 180
                pusai = WheelData(i, 16) * Pai / 180
                fai2 = WheelData(i, 17) * Pai / 180
                b1 = 0.5 * rimpd * pusai * omega * omega
                c1 = b1 * Math.Cos(fai + fai2)
                c2 = b1 * Math.Sin(fai + fai2)
                Tf(k + 5) = Tf(k + 5) + c1
                Tf(k + 6) = Tf(k + 6) - c2
                Tf(k + 7) = Tf(k + 7) + c2
                Tf(k + 8) = Tf(k + 8) + c1
            End If

        Next i

    End Sub

    Private Sub RotFVCal3_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim a1$, aa$, nreturn$, timn$
        Dim i, ib, iconv, icount, id, ierror, ie, ik As Integer
        Dim j, k, kp, krev, mf, mh, nk, nx As Integer
        Dim df, drmesh, drev, eps, fmax, revx, rmesh, ub, ubb As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics
        Dim gr2 As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Me.Show()

        CalcRes$ = ""
        timn$ = ""
        Call TimCal(0, timn$)   'ﾀｲﾏｰ計算（時間ｸﾘｱ）
        aa$ = "計算開始" + "   " + timn$
        gr2.Clear(Color.White)
        gr2.DrawString(aa$, fnt, myBrush, 1, 1)

        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Me.Refresh()

        mh = 16 'ﾊｰﾌﾊﾞﾝﾄﾞ幅
        mf = 31 'ﾌﾙﾊﾞﾝﾄﾞ幅
        Call InitialSet1()  '初期設定
        nx = Nall

        Call ResFile1U()     '結果ﾌｧｲﾙへの出力1

        If Ndisc > 0 Then
            Call DiscPrep()     '剛性円板の物性値準備
        End If

        If Nwheel > 0 Then
            Call WheelPrep()    '剛性円輪の物性値準備
        End If

        If MeshRev > 0 Then
            drev = (RevMax - RevMin) / MeshRev
        Else
            drev = 0
        End If

        rmesh = 0
        drmesh = 1 / (MeshRev + 1)
        For krev = 0 To MeshRev
            Call TimCal(1, timn$)   'ﾀｲﾏｰ計算（時間ｸﾘｱ）
            aa$ = "回転数ﾒｯｼｭNo." + Str$(krev) + "   " + timn$
            gr.Clear(Color.White)
            gr2.Clear(Color.White)
            gr2.DrawString(aa$, fnt, myBrush, 1, 1)
            If krev = 0 Then
                revx = RevMin
            ElseIf krev < MeshRev Then
                revx = RevMin + krev * drev
            ElseIf krev = MeshRev Then
                revx = RevMax
            End If

            For i = 1 To Nelem + 1
                kp = 4 * (i - 1)
                For j = 1 To 2
                    kp = kp + 1
                    RPx(kp) = 0
                Next j
            Next i

            iconv = 0
            For ik = 1 To NKmax
                For i = 1 To nx
                    Tf(i) = 0
                    For j = 1 To mf
                        Tk(i, j) = 0
                    Next j
                Next i

                Application.DoEvents()
                icount = 0
                For ie = 1 To Nelem
                    Call ElemMatrix2(ie, revx)  '要素ﾏﾄﾘｯｸｽの計算
                    Call Store()                '全体ﾏﾄﾘｯｸｽへの蓄積
                    If icount < 99 Then
                        icount = icount + 1
                    Else
                        Application.DoEvents()
                        icount = 0
                    End If
                Next ie

                If Ndisc > 0 Then
                    Call DiscSet(revx)  '剛性円板の設定
                End If

                If Nwheel > 0 Then
                    Call WheelSet(revx) '剛性円輪の設定
                End If

                If Nspring > 0 Then
                    Call SpringSet1()   'バネ支持の設定1
                End If

                If Ndamp > 0 Then
                    Call DampSet(revx)  'ﾀﾞﾝﾊﾟｰの設定
                End If

                For i = 1 To Nall
                    Tfb(i) = Tf(i)
                Next i

                If Nbound > 0 Then
                    For ib = 1 To Nbound
                        j = 8 * (Nrest(ib) - 1)
                        For id = 1 To 2
                            If Jdirect(ib, id) > 0 Then
                                If id = 1 Then
                                    k = j + 1
                                Else
                                    k = j + 3
                                End If
                                Call RestCond(k, mh, nx)    '拘束条件処理
                                Call RestCond(k + 1, mh, nx)    '拘束条件処理
                            End If
                        Next id
                    Next ib
                End If

                If MeshRev = 0 Then
                    ProgressBar1.Value = 20
                End If

                Application.DoEvents()
                Call Solver1(ierror, mh, nx) 'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1（前進側）
                If ierror < 0 Then
                    Exit Sub
                End If
                Tf(nx) = Tf(nx) / Tk(nx, mh)
                Application.DoEvents()
                Call Solver2(mh, nx) 'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（後退側）

                Call DispAssyA()    '変位の合成A
                df = 0 : fmax = 0
                For i = 1 To Nelem + 1
                    kp = 4 * (i - 1)
                    For j = 1 To 2
                        kp = kp + 1
                        ub = Math.Abs(RP(kp) - RPx(kp))
                        If ub > df Then
                            df = ub
                        End If
                        ubb = Math.Abs(RP(kp))
                        If ubb > fmax Then
                            fmax = ubb
                        End If
                    Next j
                Next i
                eps = df / fmax
                If eps < EpsCalc Then
                    iconv = 1
                    nk = ik
                    Exit For
                ElseIf ik = NKmax Then
                    nk = NKmax
                End If
                For i = 1 To Nelem + 1
                    kp = 4 * (i - 1)
                    For j = 1 To 2
                        kp = kp + 1
                        RPx(kp) = RP(kp)
                    Next j
                Next i

            Next ik

            Call ResFile3(iconv, nk, krev, eps, revx)      '結果ﾌｧｲﾙへの出力3

            Call ForceCalc(revx)   '力等の計算

            rmesh = rmesh + drmesh
            ProgressBar1.Value = 100 * rmesh

        Next krev

        Call ResFile4() '結果ﾌｧｲﾙへの出力4

        Call TimCal(1, timn$)
        a1$ = "END   " & timn$
        SwK.WriteLine(a1$)
        SwK.Close()

        gr.Clear(Color.White)
        gr2.Clear(Color.White)
        gr2.DrawString(a1$, fnt, myBrush, 1, 1)

        Label1.Text = "計算終了！"
        Label2.Text = "計算結果をファイルへ出力しました。"

        nreturn$ = Chr(13) + Chr(10)
        aa$ = "計算が終了しました。"
        aa$ = aa$ + Chr(13) + Chr(10) + CalcRes$
        Me.BringToFront()
        MsgBox(aa$, 0, "計算確認")

        gr.Dispose()
        gr2.Dispose()

        Me.Close()

    End Sub
End Class
